<?php

namespace CBapp\Model;
use \CBapp\Interfaces\InterfaceConn as InterfaceConn;

class ModelConn implements InterfaceConn
{
    private $dsn;
    private $user;
    private $pass;
    private $arr;

    public function __construct($dsn, $user, $pass, $arr)
    {
        $this->dsn = $dsn;
        $this->user = $user;
        $this->pass = $pass;
        $this->arr = $arr;
    }

    public function connect()
    {
        return new \PDO($this->dsn, $this->user, $this->pass, $this->arr);
    }

}