/* BEGIN OBJECTS ******************/
let sale = new Object();
let storeData = new Object();
let documen = new Object();
let nfce = new Object();
let nfe = new Object();
let sellerData = new Object();
let clientData = new Object();
let listItem = new Object();
let listRecebimento = new Object();
let delivery = new Object();
let importSale = new Object();

let clickExpedition = new Object();
let typeExpedition = new Object();
clickExpedition = false;

let prevRecycle = new Object();
prevRecycle.weight = parseFloat(0.0);
prevRecycle.count = parseInt(0);

let terminalBattery = new Object();
terminalBattery.value = parseFloat(0.0);
terminalBattery.count = parseInt(0);
/**********************************/

//enter event focus input, set button click
document.addEventListener('keydown', function(e) {
    if(e.key == "Enter"){
        //cdchamada -> cpf/cnpj
        if ($('#cdchamada').is(":focus")) {
            getClient();
        }     
        //cep
        if ($('#nmcep').is(":focus")) {
            $('#getCepWshop').click();
        }         
        //payment
        if ($('#valorRecebimento').is(":focus")) {
            $('#item_submit_recebimento').click();
        }            
    }
});


/* BEGIN DOCUMENT AUTO *******************************************************************
 ****************************************************************************************/
$(document).ready(function () {
    

    $(window).keydown(function(event){
        if(event.keyCode == 13) {
          event.preventDefault();
          return false;
        }
      });

    /** Open First Form **/
    openForm('form_client');
    /*********************/

    /** Get Combos *************/
    calcTotalRecebimentoList();
    comboParcelaRecebimento();
    calcTotalItemList();
    comboRecycleBool();
    comboRecebimento();
    comboUsers('seller');
    comboUsers('technical');
    comboExpedition();
    //comboChannel();
    /***************************/    

    //select auto Seller
    setTimeout(() => {
        //userIdLog = $('#user_id_log').val();
        //$("#combo-user-seller").val(userIdLog);

        //sorting combo-user-technical
        $('#combo-user-technical').addClass('whatever');
        sortingCombo();
    }, 1000);

    //css atack *********************************
    let comboUserSeller = $('#combo-user-seller');
    comboUserSeller.css('border-color', 'gray');

    let comboUserTechnical = $('#combo-user-technical');
    comboUserTechnical.css('border-color', 'gray');
    let expedition = $('#combo-expedition');
    expedition.css('border-color', 'gray');
    let channel = $('#combo-channel');
    channel.css('border-color', 'gray');
    //*******************************************/

    id('nrtelefone').onkeyup = function(){
		parent.maskPhone( this, mtel );
    }
    id('nrpager').onkeyup = function(){
		parent.maskPhone( this, mtel );
    }
    id('nrtelcomercial').onkeyup = function(){
		parent.maskPhone( this, mtel );
    }
    id('nrcodpager').onkeyup = function(){
		parent.maskPhone( this, mtel );
    }
    id('consumer_final_phone').onkeyup = function(){
		parent.maskPhone( this, mtel );
    }

    setInterval(() => {
        checkForms();
    }, 100);

    /** Get Products Wshop ***********************************************
    **********************************************************************/
    apiWshopListProduct(function (sResponse) {
        //Obj sResponse to Array product *********************************  
        let product = [];
        sResponse.product.forEach(function (p) {
            product.push({
                label: p.nmproduto,
                cdchamada: p.cdchamada,
                nmproduto: p.nmproduto,
                idproduto: p.idproduto,
                vlprecocusto: p.vlprecocusto,
                vlprecovenda: p.vlprecovenda,
                cdgrupo: p.cdgrupo,
                nmgrupo: p.nmgrupo,
                idgrupo: p.idgrupo,
                pesoliquido: p.pesoliquido,
                dsfamilia: p.dsfamilia,
                idfamilia: p.idfamilia,
                dscodigo: p.dscodigo,
            })

        });
        /**Obj sResponse to Array product *********************************
         *******************************************************************/

        /**Autocomplete Jquery ********************************************
        *******************************************************************/
        $(function () {
            $("#item_nmproduto").autocomplete({
                source: product,
                focus: function (event, ui) {
                    event.preventDefault();
                    $(this).val(ui.item.label);
                },
                select: function (event, ui) {
                    event.preventDefault();
                    $(this).val(ui.item.label);
                    item =
                        {
                            cdchamada: ui.item.cdchamada,
                            nmproduto: ui.item.nmproduto,
                            idproduto: ui.item.idproduto,
                            vlprecocusto: ui.item.vlprecocusto,
                            vlprecovenda: ui.item.vlprecovenda,
                            cdgrupo: ui.item.cdgrupo,
                            nmgrupo: ui.item.nmgrupo,
                            idgrupo: ui.item.idgrupo,
                            pesoliquido: ui.item.pesoliquido,
                            dsfamilia: ui.item.dsfamilia,
                            idfamilia: ui.item.idfamilia,
                            dscodigo: ui.item.dscodigo
                        };

                    //Prepare form to type item selected
                    prepareFormItem(item);

                    //Focus input to type item selected
                    if (getFirstNameStr(item.nmgrupo) == 'BATERIA' || getFirstNameStr(item.nmgrupo) == 'BATERIAS') {
                        $('#item_vldesconto').focus();
                        var prevRecycleWeight = item.pesoliquido - item.pesoliquido * 7/100;
                        prevRecycleWeight = prevRecycleWeight.toFixed(3);                        
                        $('#prevRecycleWeight').val(prevRecycleWeight);
                        $('#weight').val(item.pesoliquido);                        
                    } else {
                        $('#item_qtdproduto').focus();
                    }
                    // Set values to inputs values
                    $("#item_vldesconto").val('0,00');
                    $('#item_cdchamada').val(ui.item.cdchamada);
                    $("#item_selected_description").text(ui.item.nmproduto);
                    $('#item_idproduto').val(ui.item.idproduto);
                    $('#item_vlprecocusto').val(ui.item.vlprecocusto);
                    $("#item_vlprecovenda").val(formatValueBrl(ui.item.vlprecovenda));
                    $("#item_vltotal").val(formatValueBrl(ui.item.vlprecovenda));
                    $('#item_cdgrupo').val(ui.item.cdgrupo);
                    $('#item_nmgrupo').val(ui.item.nmgrupo);
                    $('#item_idgrupo').val(ui.item.idgrupo);
                    $('#item_dsfamilia').val(ui.item.dsfamilia);
                    $('#item_idfamilia').val(ui.item.idfamilia);
                    $('#item_dscodigo').val(ui.item.dscodigo);
                }
            });
        });
        /**Autocomplete Jquery ********************************************
        *******************************************************************/
    });
    /** Get Products Wshop ***********************************************
    **********************************************************************/

    /** Mask CPF/CNPJ *******************************************************/
    $(document).on('keydown', '[data-mask-for-cpf-cnpj]', function (el) {

        var digit = el.key.replace(/\D/g, '');
    
        var value = $(this).val().replace(/\D/g, '');
    
        var size = value.concat(digit).length;
    
        $(this).mask((size <= 11) ? '000.000.000-00' : '00.000.000/0000-00');
    });
    /** END Mask CPF/CNPJ ***************************************************/

    /** Mask CEP *******************************************************/
    $(document).on('keydown', '[data-mask-for-cep]', function (el) {

        var digit = el.key.replace(/\D/g, '');
    
        var value = $(this).val().replace(/\D/g, '');
    
        var size = value.concat(digit).length;
    
        $(this).mask('00000-000');
    });
    /** END Mask CEP ***************************************************/

});//END (document).ready
/* END DOCUMENT AUTO *********************************************************************
 ****************************************************************************************/



/* BEGIN WORK FORMS **********************************************************************
 ****************************************************************************************/
function checkForms() {
    checkFormClient();
    checkFormItem();
    checkFormRecebimento();
    checkFormExpedition();
    blockFormInportSale();
}
function disableElementsForm(form) {
    if (form == 'form_item') {
        $('#item_qtdproduto').attr('disabled', 'true');
        $('#item_vlprecovenda').attr('disabled', 'true');
        $('#item_vldesconto').attr('disabled', 'true');
        $('#item_vltotal').attr('disabled', 'true');
        $('#item_idbat').attr('disabled', 'true');
        $('#combo-recycle-bool').attr('disabled', 'true');
    }
}
function cleanForm(form, element) {
    if (element.id != '') {
        $('#' + element.id).css('display', 'none');
    }

    //form_item
    if (form == 'form_item') {
        $('#item_cdchamada').val('');
        $('#item_idproduto').val('');
        $('#item_vlprecocusto').val('');
        $("#item_vlprecovenda").val('');
        $('#item_cdgrupo').val('');
        $('#item_nmgrupo').val('');
        $('#item_idgrupo').val('');
        $('#item_dsfamilia').val('');
        $('#item_idfamilia').val('');
        $('#hand_point_product').css('display', 'none');
        $('#item_selected_description').html("<i style='font-size: 80%;'>- Sem Produtos...</i>");
        $('#item_submit').attr('disabled', 'true');
        $('#item_submit').removeAttr('onclick');
        $('#prevRecycleWeight').val(0);
        $('#weight').val(0);
        disableElementsForm(form);

    }

    if (form == 'form_recebimento') {
        let dropdown = $('#combo-parcela-recebimento');
        dropdown.empty();
        dropdown.append('<option value="" selected="true" disabled>--Selecione--</option>');
        dropdown.prop('selectedIndex', 0);
    }

    $('#' + form)[0].reset();
}
function openForm(form) {
    $('#form_client').fadeOut(0);
    $('#form_item').fadeOut(0);
    $('#form_recebimento').fadeOut(0);
    $('#form_expedition').fadeOut(0);
    $('#' + form).fadeIn(500);
}
function blockFormInportSale() {
    if(importSale == true){
        blockFormClient();
        blockFormItem();

    if(clickExpedition == false){
        clickExpedition = true;
        $('#faseExpedition').click();
        resetFormExpedition();        
    }

    }
}
/* END WORK FORMS ***********************************************************************
 ****************************************************************************************/



/* BEGIN CLIENT **************************************************************************
 ****************************************************************************************/
function blockFormClient() {
    $('#getClientCall').removeAttr('onclick'); 
    $('#cdchamada').attr('disabled', 'true');
    $('#nmpessoa').attr('disabled', 'true');
    $('#rg').attr('disabled', 'true');
    $('#nrinscrmun').attr('disabled', 'true');
    $('#nrinscrmun').css('background-color', 'whitesmoke');
    $('#inscestadual').attr('disabled', 'true');
    $('#inscestadual').css('background-color', 'whitesmoke');
    $('#nmfantasia').attr('disabled', 'true');
    $('#nmfantasia').css('background-color', 'whitesmoke');
    $('#nrpager').attr('disabled', 'true');
    $('#nrtelefone').attr('disabled', 'true');
    $('#nrtelcomercial').attr('disabled', 'true');
    $('#nrcodpager').attr('disabled', 'true');
    $('#nmcep').attr('disabled', 'true');
    $('#nmcidade').attr('disabled', 'true');
    $('#nmbairro').attr('disabled', 'true');
    $('#iduf').attr('disabled', 'true');
    $('#nmendereco').attr('disabled', 'true');
    $('#nrlogradouro').attr('disabled', 'true');
    $('#dscomplemento').attr('disabled', 'true');
    $('#dscomplemento').css('background-color', 'whitesmoke');
    $('#email').attr('disabled', 'true');
    $('#email').css('border-color', 'gray');
    $('#getClientWshop').removeAttr('onclick');
    $('#getClientReceita').removeAttr('onclick');
    $('#getAddress').removeAttr('onclick');
}
function checkFormClient() {
    
    var idpessoa = $('#idpessoa').val();    
    var nrcgc_cic = $('#cdchamada').val();
    var cdchamada = $('#cdchamada').val(); cdchamada = cdchamada.replace(/[^0-9]/g,'');
    var nmpessoa = $('#nmpessoa').val();
    var rg = $('#rg').val();
    var nrinscrmun = $('#nrinscrmun').val();
    var inscestadual = $('#inscestadual').val();
    var nmfantasia = $('#nmfantasia').val();
    var nrpager = $('#nrpager').val();
    var nrtelefone = $('#nrtelefone').val();
    var nrtelcomercial = $('#nrtelcomercial').val();
    var nrcodpager = $('#nrcodpager').val();
    var nmcep = $('#nmcep').val();
    var nmcidade = $('#nmcidade').val();
    var nmbairro = $('#nmbairro').val();
    var iduf = $('#iduf').val();
    var nmendereco = $('#nmendereco').val();
    var nrlogradouro = $('#nrlogradouro').val();
    var dscomplemento = $('#dscomplemento').val();
    var email = $('#email').val();
    var dtcadastro = $('#dtcadastro').val();
    var idbairro = $('#idbairro').val();
    var idcidade = $('#idcidade').val();

    if(cdchamada == '900000001'){

        //consumer_final_name *************
        blockFormClient();               
        $('#div_nmpessoa').fadeOut();
        $('#div_final_name').fadeIn();
        $('#div_final_phone').fadeIn();

        var idpessoa = $('#idpessoa').val();
        var consumer_final_name = $('#consumer_final_name').val();
        var phone = $('#consumer_final_phone').val(); 
        var consumer_final_phone = phone.replace(/[^0-9]/g,'');

        if(consumer_final_name.length > 0 && phone.length > 11){
            $('#step1').addClass('active');
        }

        cli =
            {
                nrcgc_cic: nrcgc_cic,
                cdempresa: cdempresa,
                idpessoa: idpessoa,
                cdchamada: cdchamada,
                nmpessoa: nmpessoa,  
                consumer_final_name: consumer_final_name,
                consumer_final_phone: consumer_final_phone,
                rg: rg,          
                nrinscrmun: nrinscrmun,
                inscestadual: inscestadual,
                nmfantasia: nmfantasia,
                nrpager: nrpager,
                nrtelefone: nrtelefone,
                nrtelcomercial: nrtelcomercial,
                nrcodpager: nrcodpager,
                phones: '',
                nmcep: nmcep,
                nmcidade: nmcidade,
                nmbairro: nmbairro,
                iduf: iduf,
                nmendereco: nmendereco,
                nrlogradouro: nrlogradouro,
                dscomplemento: dscomplemento,
                email: email,
                dtcadastro: dtcadastro,
                idbairro: idbairro,
                idcidade: idcidade
            }
        
        clientData = cli;
        return true;
        //*********************************

    } else {

        //consumer_final_name and phone *******
        $('#div_final_name').fadeOut(); 
        $('#div_final_phone').fadeOut();
        //*************************************

        //create var validate cpf/cnpj
        

        if(cdchamada.length > 11) {
            $(".docPJ").each(function() {
                $(this).css('background-color', 'white');
                $(this).removeAttr('readonly');                                             
            });
        } else {
            $(".docPJ").each(function() {
                $(this).css('background-color', 'whitesmoke');
                $(this).attr('readonly', 'true');
            });
        }

        var validateDocument;
        if(cdchamada.length == 11 || cdchamada.length == 14) {
            validateDocument = ValidarCpfCnpj(cdchamada);
        }

        if(validateDocument == false){
            $('#validateDocument').css('display', 'inherit');
            $('#step1').removeClass('active');
            return false;
        } else {
            $('#validateDocument').css('display', 'none');
            $('#step1').addClass('active');
        }

    
        /** All Phone *****************************************************************************************************/
        /*----------------------------------------------------------------------------------------------------------------*/
        let phones = '';
        _nrpager = nrpager; _nrtelefone = nrtelefone; _nrtelcomercial = nrtelcomercial;_nrcodpager = nrcodpager;
        if(_nrtelefone.length >= 13){_nrtelefone = _nrtelefone.replace(/[^0-9]/g,'');phones = phones+','+_nrtelefone;}
        if(_nrpager.length >= 13){_nrpager = _nrpager.replace(/[^0-9]/g,'');phones = phones+','+_nrpager;}
        if(_nrtelcomercial.length >= 13){_nrtelcomercial = _nrtelcomercial.replace(/[^0-9]/g,'');phones = phones+','+_nrtelcomercial;}
        if(_nrcodpager.length >= 13){_nrcodpager = _nrcodpager.replace(/[^0-9]/g,'');phones = phones+','+_nrcodpager;}    
        if(phones.charAt(0) === ','){phones = phones.substr(1);}
        /*----------------------------------------------------------------------------------------------------------------*/
        /** End All Phone *************************************************************************************************/
        
        //Get client cdempresa
        cdempresa = $('#cdempresa_user_log').val();
    
        cli =
            {
                nrcgc_cic: nrcgc_cic,
                cdempresa: cdempresa,
                idpessoa: idpessoa,
                cdchamada: cdchamada,
                nmpessoa: nmpessoa,
                consumer_final_name: '',
                consumer_final_phone: '',
                rg: rg,          
                nrinscrmun: nrinscrmun,
                inscestadual: inscestadual,
                nmfantasia: nmfantasia,
                nrpager: nrpager,
                nrtelefone: nrtelefone,
                nrtelcomercial: nrtelcomercial,
                nrcodpager: nrcodpager,
                phones: phones,
                nmcep: nmcep,
                nmcidade: nmcidade,
                nmbairro: nmbairro,
                iduf: iduf,
                nmendereco: nmendereco,
                nrlogradouro: nrlogradouro,
                dscomplemento: dscomplemento,
                email: email,
                dtcadastro: dtcadastro,
                idbairro: idbairro,
                idcidade: idcidade
            }
    
        var Phones = nrpager.length + nrtelefone.length + nrtelcomercial.length + nrcodpager.length;
    
        if (Phones < 13) {
            $('#step1').removeClass('active');
            return false;
        }
        //cdchamada = cdchamada.replace(" ","");
        if (
            cdchamada.length < 7 || nmpessoa < 7 ||
            nmcep.length < 8 || nmcidade.length < 4 ||
            nmbairro.length < 4 || iduf.length != 2 ||
            nmendereco.length < 2) {
            $('#step1').removeClass('active');
            return false;
        } else {

            if(cdchamada.length <= 10) {
                $('#step1').removeClass('active');
            } else {
                clientData = cli;
                $('#step1').addClass('active');
                return true;
            }

        }

    }//cdchamada
    
}
function apiWshopGetClientPhone(dataRequest, dataResponse) {
    let request = { function: 'apiWshopGetClientPhone', phone: dataRequest }
    CBappApi(request, (response) => {
        dataResponse(response);
    });
}
function getClientCall() {

    let ramal = $('#user_ramal').val();

    let modaProcess = { action: 'open' };
    modalProcess(modaProcess);

    getClientFoneAsterisk((Response) => {

        /* Get n° phone conected in channel seller ******/
        /************************************************/                
        Response.forEach(function (data) {
            if (data.caller.number == ramal) {
                cNumber = data.connected.number
            }
        });
        /************************************************/

        //if(cNumber == 0){toastMsg('Nº Vázio'); modaProcess.action = 'close'; }        
        var nr = cNumber.split('');
        switch (nr.length) {

            case 11:
                clientNumber = /*'('+nr[0]+nr[1]+')'+nr[2]+*/nr[3] + nr[4] + nr[5] + nr[6] + nr[7] + nr[8] + nr[9] + nr[10];
                apiWshopGetClientPhone(clientNumber, (resp) => {
                    try {
                        populateFormClient(resp[0]);
                        modaProcess.action = 'close';
                        modalProcess(modaProcess);
                    }
                    catch (err) {
                        toastMsg('Cliente não encontrado.');
                        modaProcess.action = 'close';
                        modalProcess(modaProcess);
                    }
                })
                break;
            case 10:
                clientNumber = /*'('+nr[0]+nr[1]+')'+*/nr[2] + nr[3] + nr[4] + nr[5] + nr[6] + nr[7] + nr[8] + nr[9];
                apiWshopGetClientPhone(clientNumber, (resp) => {
                    try {
                        populateFormClient(resp[0]);
                        modaProcess.action = 'close';
                        modalProcess(modaProcess);
                    }
                    catch (err) {
                        toastMsg('Cliente não encontrado.');
                        modaProcess.action = 'close';
                        modalProcess(modaProcess);
                    }
                })
                break;
            case 4:
                toastMsg('Comunicação entre Ramais');
                modaProcess.action = 'close';
                modalProcess(modaProcess);
                break;
            case 0:
                toastMsg('Linha livre!');
                modaProcess.action = 'close';
                modalProcess(modaProcess);
                break;
        }
    })
}
function apipGetAddressCep() {

    let modaProcess = { action: 'open' };
    modalProcess(modaProcess);

    let nmcep = $('#nmcep').val();
    let dataRequest = { function: 'apiWshopGetAddressCep', nmcep: nmcep};
    
    CBappApi(dataRequest, (dataResponse) => {

        let address = dataResponse;

        if(!address){
            toastMsg('CEP não encontrado');
        } else {            
            $('#nmcidade').val(address.nmcidade);
            $('#nmbairro').val(address.nmbairro);
            $('#nmendereco').val(address.nmlogradouro);
            $('#iduf').val(address.cduf);
            $('#idbairro').val(address.idbairro);
            $('#idcidade').val(address.idcidade);

        }        
        modaProcess.action = 'close';
        modalProcess(modaProcess);
    });
}
function getClient() {
    let column = 'cdchamada';
    let cpf_cnpj = $('#cdchamada').val();
    let column_value = $('#cdchamada').val();
    let sttipopessoa = $("input[name='sttipopessoa']:checked").val();
    column_value = column_value.replace(/[^0-9]/g,'');
    let dataRequest = { function: 'apiWshopGetClient', column: column, column_value: column_value, sttipopessoa: sttipopessoa }

    let modaProcess = { action: 'open' };
    modalProcess(modaProcess);

    apiWshopGetClient(dataRequest, (dataResponse) => {

        if(dataResponse.code != 200){
            toastMsg('Cliente não encontrado');
            modaProcess.action = 'close';
            modalProcess(modaProcess);
        }
        let client = dataResponse;
        client.doc = cpf_cnpj;
        populateFormClient(client);

        modaProcess.action = 'close';
        modalProcess(modaProcess);
    });
}
function getPjReceitaFederal() {

    let modaProcess = { action: 'open' };
    modalProcess(modaProcess);

    let cpf_cnpj = $('#cdchamada').val()
    let request = $('#cdchamada').val()
    request = request.replace(/[^0-9]/g,'');

    getClientReceitaFederal(request, (response) => {
        try {            
            
            let client = response;
            let nmfantasia = client.fantasia;

            fone = client.telefone.replace(" ", "");
            client.fone = fone.split(" /");

            if(client.fone.length > 1) {                
                fone1 = client.fone[0];
                fone2 = client.fone[1].replace(" ", "");
            } else {
                fone1 = fone;
                fone2 = '';
            }

            dataClient = {
                cdchamada: request,
                nmfantasia: nmfantasia,
                nmpessoa: client.nome,
                nrtelefone: client.fone[0],
                nrtelcomercial: client.fone[1],
                nrcodpager: client.fone[2],
                nmcep: client.cep,
                nmcidade: client.municipio,
                nmbairro: client.bairro,
                iduf: client.uf,
                nmendereco: client.logradouro,
                nrlogradouro: client.numero,
                dscomplemento: client.complemento
            }

            dataClient.doc = cpf_cnpj;
            dataClient.nmcep = dataClient.nmcep.replace(".", "");
            dataClient.nmendereco = dataClient.nmendereco.replace("R ", "RUA ");
            dataClient.nmendereco = dataClient.nmendereco.replace("AV ", "AVENIDA ");

            populateFormClient(dataClient);
            modaProcess.action = 'close';
            modalProcess(modaProcess);

        }
        catch (err) {
            toastMsg('DADOS NÃO ENCONTRADOS');
            modaProcess.action = 'close';
            modalProcess(modaProcess);
        }
    });




}
function apiWshopGetClient(dataRequest, dataResponse) {
    let request = dataRequest;
    CBappApi(request, (response) => {

        dataResponse(response);

    });

}
function populateFormClient(client) {

    

    if(client.cdchamada.length > 0){
    
        cleanForm('form_client', '');
        
        $('#cdchamada').val(client.doc);        

        if(client.cdchamada.length > 11) {
            $('#inscestadual').val(client.nrincrest_rg);
        } else {
            $('#rg').val(client.nrincrest_rg);
            if(!client.inscest_pfisica === ''){
                $('#inscestadual').val(client.inscest_pfisica);
            }
        }

        if(client.cdchamada == '900000001'){
            client.nrcgc_cic = client.cdchamada;
        }

        $('#idpessoa').val(client.idpessoa);
        $('#cdchamada').val(client.nrcgc_cic);
        $('#nrinscrmun').val(client.nrinscrmun);
        $('#nmfantasia').val(client.nmfantasia);
        $('#nmpessoa').val(client.nmpessoa);
        $('#nrpager').val(client.nrpager);
        $('#nrtelefone').val(client.nrtelefone);
        $('#nrtelcomercial').val(client.nrtelcomercial);
        $('#nrcodpager').val(client.nrcodpager);
        $('#nmcep').val(client.nmcep);
        $('#nmcidade').val(client.nmcidade);
        $('#nmbairro').val(client.nmbairro);
        $('#iduf').val(client.iduf);
        $('#nmendereco').val(client.nmendereco);
        $('#nrlogradouro').val(client.nrlogradouro);
        $('#dscomplemento').val(client.dscomplemento);
        $('#email').val(client.email);
        $('#dtcadastro').val(client.dtcadastro);
        $('#idbairro').val(client.idbairro);
        $('#idcidade').val(client.idcidade);
    }
}
function prepareDataClient(iddocumento) {

    /** Clean Obj listItem, listRecebimento  */
    listItem = {};
    listRecebimento = {};

    /** Clean table list */
    $('#tblItem > tbody tr').each(function (i) {
        this.parentNode.removeChild(this);
    });

    $('#tblRecebimento > tbody tr').each(function (i) {
        this.parentNode.removeChild(this);
    });

    setTimeout(() => {
        /** new document */
        apiWshopGetDataSale(iddocumento);
    }, 500);

}
function getCep() {

    //Erro 01 = CEP não encontrado.
    //Erro 02 = Formato de CEP inválido.
    //Erro 03 = CEP sem valor.

    //Initialize preload
    //$('#preload').fadeIn();
    let modaProcess = { action: 'open' };
    modalProcess(modaProcess);

    function cleanDataAddrres() {
        // Clean Data Address.
        $('#nmendereco').val('');
        $('#nmbairro').val('');
        $('#nmcidade').val('');
        $('#iduf').val('');
    }

    //Set "..." inputs.
    $('#nmendereco').val('...');
    $('#nmbairro').val('...');
    $('#nmcidade').val('...');
    $('#iduf').val('...');

    //Get cep input
    let cep = $('#nmcep').val()
    //Remove char ".-"
    cep = cep.replace(/[^0-9]/g,'');

    apiCep(cep, function (response) {

        if (response.acert) {

            //Atualiza os campos com os valores da consulta.
            $("#nmendereco").val(response.data.logradouro);
            $("#nmbairro").val(response.data.bairro);
            $("#nmcidade").val(response.data.localidade);
            $("#iduf").val(response.data.uf);

            //Close preload
            //$('#preload').fadeOut();
            modaProcess.action = 'close';
            modalProcess(modaProcess);

        } else {

            cleanDataAddrres();

            //Close preload
            //$('#preload').fadeOut();            
            modaProcess.action = 'close';
            modalProcess(modaProcess);

            toastMsg('ERROR: ' + response.erro_text);
        }
    });
}
/* END CLIENT ****************************************************************************
 ****************************************************************************************/



/* BEGIN ITEM ****************************************************************************
 ****************************************************************************************/
function blockFormItem() {
    $('#item_nmproduto').attr('disabled', 'true');
}
function checkFormItem() {    
    let totalItem = $('#productResult').text();
    let statusClient = checkFormClient();
    if(!statusClient){
        $('#item_nmproduto').attr('disabled', 'true');
    } else {
        $('#item_nmproduto').removeAttr('disabled');
    }

    if (totalItem != '0,00') {
        $('#step2').addClass('active');
        return true;
    } else {
        $('#step2').removeClass('active');
        return false;
    }
}
function getItem() {

    let item_cdchamada = $('#item_cdchamada').val();
    let item_nmproduto = $("#item_selected_description").text();
    let item_idproduto = $('#item_idproduto').val();
    let item_vlprecocusto = $('#item_vlprecocusto').val();
    let item_vlprecovenda = $("#item_vlprecovenda").val();
    let item_cdgrupo = $('#item_cdgrupo').val();
    let item_nmgrupo = $('#item_nmgrupo').val();
    let item_idgrupo = $('#item_idgrupo').val();
    let item_dscodigo = $('#item_dscodigo').val();
    let item_dsfamilia = $('#item_dsfamilia').val();
    let item_idfamilia = $('#item_idfamilia').val();
    let item_qtdproduto = $('#item_qtdproduto').val();
    let item_vldesconto = $('#item_vldesconto').val();
    let item_vltotal = $('#item_vltotal').val();
    let item_idbat = $('#item_idbat').val();
    let combo = id('combo-recycle-bool');
    let item_recycle = combo.options[combo.selectedIndex].value;
    let prevRecycleWeight = $('#prevRecycleWeight').val();
    let weight = $('#weight').val();

    item =
        {
            cdchamada: item_cdchamada,
            nmproduto: item_nmproduto,
            idproduto: item_idproduto,
            vlprecocusto: item_vlprecocusto,
            vlprecovenda: formatValueNumeric(item_vlprecovenda),
            cdgrupo: item_cdgrupo,
            nmgrupo: item_nmgrupo,
            idgrupo: item_idgrupo,
            dsfamilia: item_dsfamilia,
            dscodigo: item_dscodigo,
            idfamilia: item_idfamilia,
            qtdproduto: parseInt(item_qtdproduto),
            vldesconto: formatValueNumeric(item_vldesconto),
            vltotal: formatValueNumeric(item_vltotal),
            idbat: item_idbat,
            recycle: item_recycle,
            prevRecycleWeight: prevRecycleWeight,
            weight: weight
        }

    return item;
}
function populateFormItem(i) {

    i.forEach((item, index) => {

        let nmgrupo = getFirstNameStr(item.nmgrupo);

        if (item.vldesconto > 0) { item.recycle = 1; }

        /** Equalize object 
        *********************************/
        item.vlprecocusto = item.vlcusto;
        delete item.vlcusto;

        item.vlprecovenda = item.vlunitario;
        delete item.vlunitario;

        item.qtdproduto = item.qtitem;
        delete item.qtitem

        item.vltotal = item.vlmovimento;
        delete item.vlmovimento;

        item.idbat = item.dsitemcomplementar;
        delete item.dsitemcomplementar;
        /********************************/

        let separator = '';
        if (getFirstNameStr(item.nmgrupo) == 'BATERIA' || getFirstNameStr(item.nmgrupo) == 'BATERIAS') {
            if (item.qtdproduto > 1) {
                toastMsg('ERROR: Impossível informar Nº série<br> para  quantidades de itens da Nota. <br> Por favor, corrija o lançamento. ');
                return false;
            }

            if (item.idbat == null) {
                toastMsg('ERROR: Bateria sem Nº série. <br> Favor corrigir o lançamento da Nota.');
                return false;
            }

            separator = `&nbsp;<span class="fa fa-car-battery" style="color: darkblue; font-size: 1.8vh;">&nbsp;<i class="fa fa-arrow-right" style="font-size: 1.5vh;"></i></span>&nbsp;`;
        }

        let templateItem = `<tr>
            <td style="width: 60%; text-align: left;">${item.nmproduto} ${separator} ${item.idbat}</td>
            <td style="width: 8%;">${item.qtdproduto}</td>
            <td style="width: 8%;">${formatValueBrl(item.vlprecovenda)}</td>
            <td style="width: 8%;">${formatValueBrl(item.vldesconto)}</td>
            <td style="width: 8%;" class="valueProduct">${formatValueBrl(item.vltotal)}</td>
            <td style="width: 8%;">...</td>
        </tr>`

        let localInsertItem = id('map-insert-item');
        localInsertItem.insertAdjacentHTML("beforebegin", templateItem);

    })
    listItem = response.item;

    calcTotalItemList();
    cleanForm('form_item', '');
    $('#item_nmproduto').attr('disabled', 'true')

}
function insertItemList() {

    item = getItem();
    var separator = '';
    var nmgrupo = getFirstNameStr(item.nmgrupo);

    var tbValue;
    var tbCount;
    
    if (nmgrupo == 'TERMINAIS') {
        if(item.qtdproduto > 0){
            terminalBattery.value = terminalBattery.value + formatValueNumeric(item.vlprecovenda * item.qtdproduto);
            terminalBattery.count = parseInt(terminalBattery.count + item.qtdproduto);

            tbValue = formatValueNumeric(item.vlprecovenda * item.qtdproduto);
            tbCount = parseInt(item.qtdproduto);                        
        }
    }

    if (nmgrupo == 'BATERIA' || nmgrupo == 'BATERIAS') {
        /*if (item.idbat === '') {
            toastMsg('ERROR: Informe o ID da Bateria');
            $('#item_idbat').focus();
            return false;
        }
        if (item.idbat.length < 10) {
            toastMsg('ERROR: ID da Bateria inválido.');
            $('#item_idbat').focus();
            return false;
        }*/
        if (item.recycle === '') {
            toastMsg('ERROR: Informe o campo Sucata.');
            id('combo-recycle-bool').focus();
            return false;
        }
        if (item.recycle == 1) {
            if(item.prevRecycleWeight > 0){                
                
                var weight = parseFloat(item.prevRecycleWeight);
                calc = prevRecycle.weight + weight;
                var precision = parseInt(precisionRecycleWeight(calc));
                calc = parseFloat(calc.toPrecision(precision));
                prevRecycle.weight = calc;
            }
            var count = parseInt(item.recycle);
            prevRecycle.count = parseInt(prevRecycle.count + count);
        } else {
            item.prevRecycleWeight = 0;
            item.recycle = 0;
            $('#prevRecycleWeight').val(0);
            $('#weight').val(0);
        }
        separator = `&nbsp;<span class="fa fa-car-battery" style="color: darkblue; font-size: 1.8vh;">&nbsp;<i class="fa fa-arrow-right" style="font-size: 1.5vh;"></i></span>&nbsp;`;
    }

    //0 recycle group != battery
    if (getFirstNameStr(item.nmgrupo) == 'BATERIA' || getFirstNameStr(item.nmgrupo) == 'BATERIAS') {
        item.recycle = 0;
    }

    //itemid based datetime
    let itemId = getDateTime().replace(/[^0-9]/g,'');

    //insert item obj listItem
    listItem[itemId] = item;

    let templateItem = `<tr id="${itemId}">
        <td style="width: 60%; text-align: left;">${separator} ${item.nmproduto} </td>
        <td style="width: 8%;">${item.qtdproduto}</td>
        <td style="width: 8%;">${formatValueBrl(item.vlprecovenda)}</td>
        <td style="width: 8%;">${formatValueBrl(item.vldesconto)}</td>
        <td style="width: 8%;" class="valueProduct">${formatValueBrl(item.vltotal)}</td>
        <td style="width: 8%;"><span title="Excluir!" onclick="removeItemList('${itemId}'), removeRecycleWeight('${item.prevRecycleWeight}', '${item.recycle}'), removTerminalBattery('${tbValue}', '${tbCount}')" class="fa fa-trash-alt hvr-pop" style="font-size: 18px; cursor: pointer;"></span></td>
    </tr>`

    let localInsertItem = id('map-insert-item');
    localInsertItem.insertAdjacentHTML("beforebegin", templateItem);

    calcTotalItemList();
    cleanForm('form_item', '');

}
function removTerminalBattery(tbValue, tbCount){
    if(tbCount > 0){
        terminalBattery.value = formatValueNumeric(terminalBattery.value - tbValue);
        terminalBattery.count = parseInt(terminalBattery.count - tbCount);
    }
}
function precisionRecycleWeight(weight) {
    var toPrecision = 0;
    var x = weight.toString().split('.');
    if(x[0].length == 1){toPrecision = 5;}
    if(x[0].length == 2){toPrecision = 6;}
    if(x[0].length == 3){toPrecision = 7;}
    if(x[0].length == 4){toPrecision = 8;}
    if(x[0].length == 5){toPrecision = 9;}
    if(x[0].length == 6){toPrecision = 10;}
    if(x[0].length == 7){toPrecision = 11;}
    return toPrecision;
}
function removeRecycleWeight(weight, count){
    if(count > 0){     
        //weight   
        calc = prevRecycle.weight - weight; 
        var precision = parseInt(precisionRecycleWeight(calc));
        calc = parseFloat(calc.toPrecision(precision));
        prevRecycle.weight = calc;
        //count
        prevRecycle.count = prevRecycle.count - count;
    }
}
function prepareFormItem(item) {

    $("#form_item")[0].reset();
    $("#hand_point_product").css('display', 'inherit');
    $('#item_submit').removeAttr('disabled');
    $('#item_submit').attr('onclick', 'insertItemList()');

    let nmgrupo = getFirstNameStr(item.nmgrupo);

    if (getFirstNameStr(item.nmgrupo) == 'BATERIA' || getFirstNameStr(item.nmgrupo) == 'BATERIAS') {
        //Enable inputs
        $('#item_qtdproduto').removeAttr('disabled');
        $('#item_vlprecovenda').removeAttr('disabled');
        $('#item_vldesconto').removeAttr('disabled');
        $('#item_vltotal').removeAttr('disabled');
        $('#item_idbat').removeAttr('disabled');
        $('#combo-recycle-bool').removeAttr('disabled');

        //Actions
        $('#item_qtdproduto').val(1);
        $('#item_qtdproduto').attr('readonly', 'true');
        $('#item_qtdproduto').css('background-color', 'whitesmoke');

    } else {

        //Enable inputs
        $('#item_qtdproduto').removeAttr('disabled');
        $('#item_vlprecovenda').removeAttr('disabled');
        $('#item_vldesconto').removeAttr('disabled');
        $('#item_vltotal').removeAttr('disabled');

        //Actions
        $('#item_qtdproduto').val(1);
        $('#item_qtdproduto').removeAttr('readonly');
        $('#item_qtdproduto').css('background-color', 'transparent');

        //Desable inputs
        $('#item_idbat').attr('disabled', 'true');
        $('#combo-recycle-bool').attr('disabled', 'true');

    }

}
function calcTotalItemInsert() {
    //max percent = 35.01%
    /** vaor desconto / pelo valor do produto x 100 */

    //Variables declaration
    let qtdproduto = $('#item_qtdproduto').val();
    let vlprecovenda = $('#item_vlprecovenda').val();
    let vldesconto = $('#item_vldesconto').val();
    let vltotal = $('#item_vltotal');
    let total;

    //Prepare to calc    
    vldesconto = formatValueNumeric(vldesconto);
    vlprecovenda = formatValueNumeric(vlprecovenda);

    //Tratament isNaN
    if (isNaN(vldesconto) == true) { vldesconto = 0; $('#item_vldesconto').val('0,00'); }

    //Calc Total
    total = (qtdproduto * vlprecovenda - vldesconto);

    let request = { vlprecovenda: vlprecovenda, vldesconto: vldesconto }
    checkPercent(request, function (response) {
        let error = response.error;
        if (error == 1) {
            toastMsg('ERROR: ' + response.errorDesc);
            $('#item_vldesconto').val('0,00');
            calcTotalItemInsert();
            return false;
        } else {
            //Set total
            vltotal.val(formatValueBrl(total));

        }

    })
}
function calcTotalItemList() {
    var soma = 0;
    $('#tblItem > tbody tr .valueProduct').each(function (i) {
        soma += formatValueNumeric($(this).text());
    });
    $("#productResult").text(formatValueBrl(soma));
}
function removeItemList(id) {
    delete listItem[id];
    $('#' + id).remove();
    calcTotalItemList()
}
function checkPercent(request, response) {

    //Variables declaration External
    let vlDiscount = request.vldesconto;
    let vlItem = request.vlprecovenda;

    //Variables declaration Internal
    //let percentDiscount = '35.01';
    let percentDiscount = '75.01';
    let errorDesc = "Desconto máximo excedido.";
    

    //Calcs
    percentDiscountSeller = (vlDiscount / vlItem * 100);

    //Data Response
    dataResponse =
        {
            percentDiscount: percentDiscount,
            percent: percentDiscountSeller,
            errorDesc: errorDesc,
            error: 1,
        }

    if (percentDiscountSeller > percentDiscount) {
        response(dataResponse);
    } else {
        dataResponse.error = 0;
        delete dataResponse.errorDesc;
        response(dataResponse);
    }

}

/* END ITEM ******************************************************************************
 ****************************************************************************************/



/* BEGIN RECEBIMENTO *********************************************************************
 ****************************************************************************************/
function checkFormRecebimento() {

    calcSaldoRecebimento()
    calcTotalRecebimentoList()

    $('#totalVenda').text($('#productResult').text());

    let saldo = $('#saldoRecebimento').text();
    let totalVenda = $('#totalVenda').text();
    let totalRecebimento = $('#totalRecebimento').text();

    if (totalVenda == '0,00') {
        fecharRecebimentoFalse();
        return false;
    } else {
        abrirRecebimento();

        if (saldo == '0,00' && totalRecebimento == totalVenda) {
            fecharRecebimentoTrue();
            
            if(clickExpedition == false){
                clickExpedition = true;
                $('#faseExpedition').click();
                resetFormExpedition();        
            }

            return true;
        } else {
            abrirRecebimento();
            return true;
        }
    }


}
function abrirRecebimento() {
    let recebimento = $('#combo-recebimento');
    let parcelaRecebimento = $('#combo-parcela-recebimento');

    recebimento.removeAttr('disabled');
    parcelaRecebimento.removeAttr('disabled');
    $('#valorRecebimento').css('border-color', 'gray');
    $('#valorRecebimento').removeAttr('disabled');
    $('#item_submit_recebimento').removeAttr('disabled');
    $('#item_submit_recebimento').attr('onclick', 'insertRecebimentoList()');
    $('#step3').removeClass('active');
}
function fecharRecebimentoTrue() {
    let recebimento = $('#combo-recebimento');
    let parcelaRecebimento = $('#combo-parcela-recebimento');

    recebimento.attr('disabled', 'true');
    parcelaRecebimento.attr('disabled', 'true');
    $('#valorRecebimento').css('border-color', 'gray');
    $('#valorRecebimento').attr('disabled', 'true');
    $('#item_submit_recebimento').attr('disabled', 'true');
    $('#item_submit_recebimento').removeAttr('onclick');
    $('#step3').addClass('active');
}
function fecharRecebimentoFalse() {
    let recebimento = $('#combo-recebimento');
    let parcelaRecebimento = $('#combo-parcela-recebimento');

    recebimento.attr('disabled', 'true');
    parcelaRecebimento.attr('disabled', 'true');
    $('#valorRecebimento').css('border-color', 'gray');
    $('#valorRecebimento').attr('disabled', 'true');
    $('#item_submit_recebimento').attr('disabled', 'true');
    $('#item_submit_recebimento').removeAttr('onclick');
}
function populateFormRecebimento(r) {

    r.forEach((recebimento, index) => {

        /** Equalize object 
        *********************************/
        recebimento.descricaoRecebimento = recebimento.nmtprecebimento;
        delete recebimento.nmtprecebimento;

        recebimento.qtdParcela = recebimento.count;
        delete recebimento.count;

        recebimento.valorRecebimento = recebimento.sum;
        delete recebimento.sum;

        recebimento.idRecebimento = recebimento.idtprecebimento;
        delete recebimento.idtprecebimento;

        recebimento.valorParcela = (recebimento.valorRecebimento / recebimento.qtdParcela);
        /********************************/

        let templateRecebimento = `<tr id="${recebimento.idRecebimento}">
        <td style="width: 80%; text-align: left;">${recebimento.descricaoRecebimento}</td>
        <td style="width: 5%;">${recebimento.qtdParcela}</td>
        <td style="width: 5%;">${formatValueBrl(recebimento.valorParcela)}</td>
        <td style="width: 5%;" class="valueRecebimento">${formatValueBrl(recebimento.valorRecebimento)}</td>
        <td style="width: 5%;">...</td>
        </tr>`

        let localInsertRecebimento = id('map-insert-recebimento');
        localInsertRecebimento.insertAdjacentHTML("beforebegin", templateRecebimento);


    })

    listRecebimento = response.payment;

    $("#form_item")[0].reset();
    checkFormRecebimento();

}
function insertRecebimentoList() {

    let recebimento = $('#combo-recebimento').val();
    recebimento = recebimento.split('-');
    let idRecebimento = recebimento[0];

    //let saldo =  formatValueNumeric($('#saldoRecebimento').text());
    let qtdParcela = $('#comboParcelaRecebimento :selected').text();
    let descricaoRecebimento = $('#combo-recebimento :selected').text();
    let descricaoQtdParcela = $('#comboParcelaRecebimento :selected').text();
    let valorRecebimento = formatValueNumeric($('#valorRecebimento').val());
    let valorParcela = (valorRecebimento / qtdParcela);

    if (descricaoRecebimento == '--Selecione--') {
        toastMsg('ERROR: Selecione o tipo do Recebimento!');
        return false;
    }
    if (descricaoQtdParcela == '--Selecione--') {
        toastMsg('ERROR: Informe a quantidade de parcela!');
        return false;
    }
    if (valorRecebimento <= 0) {
        toastMsg('ERROR: Informe o valor!');
        return false;
    }

    recebimento =
        {
            idRecebimento: idRecebimento,
            descricaoRecebimento: descricaoRecebimento,
            valorRecebimento: valorRecebimento,
            qtdParcela: qtdParcela,
            valorParcela: valorParcela
        };


    let d = new Date();
    let dia = d.getDate(); if (dia <= '9') { dia = `0${dia}`; } //Dia
    let mes = d.getDay(); if (mes <= '9') { mes = `0${mes}`; } //Mês
    let ano = d.getFullYear();      //------------------------------- //Ano
    let hor = d.getHours(); if (hor <= '9') { hor = `0${hor}`; } //Hora
    let min = d.getMinutes(); if (min <= '9') { min = `0${min}`; } //Minuto
    let seg = d.getMilliseconds(); if (seg <= '9') { seg = `0${seg}`; } //Segundo

    let idRecList = `${dia}${mes}${ano}${hor}${min}${seg}`;

    //insert item obj Recebimento
    listRecebimento[idRecList] = recebimento;

    let templateRecebimento = `<tr id="${idRecList}">
    <td style="width: 80%; text-align: left;">${recebimento.descricaoRecebimento}</td>
    <td style="width: 5%;">${recebimento.qtdParcela}</td>
    <td style="width: 5%;">${formatValueBrl(recebimento.valorParcela)}</td>
    <td style="width: 5%;" class="valueRecebimento">${formatValueBrl(recebimento.valorRecebimento)}</td>
    <td style="width: 5%;"><span title="Excluir!" onclick="removeRecebimentoList('${idRecList}')" class="fa fa-trash-alt hvr-pop" style="font-size: 18px; cursor: pointer;"></span></td>
</tr>`

    let localInsertRecebimento = id('map-insert-recebimento');
    localInsertRecebimento.insertAdjacentHTML("beforebegin", templateRecebimento);

    checkFormRecebimento();
    cleanForm('form_recebimento', '');

}
function getSaldoRecebimento() {
    let saldo = formatValueNumeric($('#saldoRecebimento').text());
    if (saldo > 0) {
        $('#valorRecebimento').val($('#saldoRecebimento').text());
    }
}
function removeRecebimentoList(id) {
    delete listRecebimento[id];
    $('#' + id).remove();
    checkFormRecebimento()
}
function calcSaldoRecebimento() {
    let totalRecebimento = formatValueNumeric($('#totalRecebimento').text());
    let totalVenda = formatValueNumeric($('#totalVenda').text());

    saldoRecebimento = (totalVenda - totalRecebimento);
    $('#saldoRecebimento').text(formatValueBrl(saldoRecebimento));
}
function calcTotalRecebimentoList() {
    var soma = 0;
    $('#tblRecebimento > tbody tr .valueRecebimento').each(function (i) {
        soma += formatValueNumeric($(this).text());
    });
    $("#totalRecebimento").text(formatValueBrl(soma));
}
function prepareRecebimento() {

    let recebimento = $('#combo-recebimento').val();
    recebimento = recebimento.split('-');
    let recebimento_parcela = recebimento[1];

    let ComboParcela = $('#combo-parcela-recebimento');
    ComboParcela.empty();

    if (recebimento_parcela > 1) {
        ComboParcela.append('<option selected="true" disabled>--Selecione--</option>');
        for (i = 0; i < recebimento_parcela; i++) {
            ComboParcela.append($('<option></option>').attr('value', i + 1).text(i + 1));
        }
    } else {
        ComboParcela.append($('<option selected="true" disabled></option>').attr('value', 1).text(1));
    }
}
/* END RECEBIMENTO ***********************************************************************
 ****************************************************************************************/


/* BEGIN EXPEDITION **********************************************************************
 ****************************************************************************************/
function resetFormExpedition() {
    $("img[src='./assets/images/maps/set_position.gif']").css('display', 'none');
    $('#gMapAddress').text('');
    $('#complement').val('');
    $('#dataPosition').css('display', 'none');
    $("#combo-user-technical").val('1');
    $('#combo-expedition').prop('selectedIndex', 0);
    $('#pac-input').val('');
    $('#lt').val('');
    $('#lg').val('');
    $("input[name='installation']").attr("checked" , false );
}

function checkFormExpedition() {
    //let pvb = $('#pvb').val();    
    let seller = $('#combo-user-seller :selected').text();
    let statusClient = $('#step1').hasClass('active');
    let statusItem = $('#step2').hasClass('active');
    let statusRecebimento = $('#step3').hasClass('active');
    let local = $('#combo-expedition :selected').val();    
    let technical = $('#combo-user-technical :selected').text();
    let lat = $('#lt').val();
    let lgn = $('#lg').val();    
    let installation = $("input[name='installation']").is(":checked");

    //sale.pvb = pvb;
    //sale.seller = seller;
    sale.installation = installation;

    delivery.technical_id = $('#combo-user-technical').val();
    delivery.technical_name = $('#combo-user-technical :selected').text();
    delivery.addressDescription = $('#gMapAddress').text();
    delivery.addressComplement = $('#complement').val();
    delivery.geolocationDestination = $('#lt').val()+','+$('#lg').val();
    typeExpedition.local = local;

    
    function CheckStep4True() {
        $('#step4').addClass('active');
        $('#begin_attendance').removeAttr('disabled');
        $('#begin_attendance').addClass('hvr-hangx');
        $('#begin_attendance').attr('onclick', 'apiBeginSale()');
        return true;
    }
    function CheckStep4False() {
        $('#step4').removeClass('active');
        $('#begin_attendance').attr('disabled', 'true');
        $('#begin_attendance').removeClass('hvr-hangx');
        $('#begin_attendance').removeAttr('onclick');
        return true;
    }
    function finalCheckTrue() {
        $('#combo-expedition').removeAttr('disabled');
        $('#combo-user-technical').removeAttr('disabled');
        return true;
    }
    function finalCheckFalse() {
        $('#combo-expedition').attr('disabled', 'true');
        $('#combo-user-technical').attr('disabled', 'true');
        $('#begin_attendance').attr('disabled', 'true');
        $('#begin_attendance').removeAttr('onclick');
        $('#begin_attendance').removeClass('hvr-hangx');
        return false;
    }


    
    if(statusClient == false || statusItem == false || statusRecebimento == false){        
        finalCheckFalse();
    } else {
        finalCheckTrue();
        if(seller == '--Selecione--' || local == '--Selecione--' || technical == '--Selecione--' || lat === '' || lgn === '' || installation == false){
            CheckStep4False();
        } else {
            CheckStep4True();
        }
    }

}
/* END BEGIN EXPEDITION ******************************************************************
 ****************************************************************************************/



/* BEGIN SALES ***************************************************************************
 ****************************************************************************************/
function apiWshopListSales() {
    let seller;
    let tbody = id('tbody');
    let request = { function: 'apiWshopListSales'}
    $("#tbody").empty();

    CBappApi(request, (response) => {

        //set date input
        //$('#date').val(response.date);

        let vlTotal = formatValueBrl(parseFloat(response.value_total));

        //set date text
        $('#date_text').html(response.date);
        $('#adm_text').html('&nbsp;- VENDAS ' + response.row_count + ', TOTAL ' + vlTotal);

        //array sales
        let sales = response.sales;
        
        sales.forEach((wshop, index) => {            

            let phone1 = wshop.nrtelefone; if (phone1 == null) { phone1 = '' }
            let phone2 = wshop.nrtelcomercial; if (phone2 == null) { phone2 = '' } else { phone2 = '| ' + phone2 }           

            if(!wshop.seller){
                seller = ' VENDEDOR ???'
            } else {
                if(wshop.seller.length > 0){                
                    seller = wshop.seller[0].nmpessoa;
                 }
            }

            let tmpl = `<tr id="sale-${wshop.iddocumento}" class="modal-trigger" data-modal="modal_wshop_sale" style="cursor: pointer;" style="overflow: auto;">
                        <td onclick="prepareDataClient('${wshop.iddocumento}');" id="td-iddocumento-${wshop.iddocumento}">${wshop.iddocumento}</td>
                        <td onclick="prepareDataClient('${wshop.iddocumento}');" id="td-cliente-${wshop.iddocumento}">${wshop.nmpessoa}</td>
                        <td onclick="prepareDataClient('${wshop.iddocumento}');" id="td-bairro-${wshop.iddocumento}">${wshop.nmbairro}</td>
                        <td onclick="prepareDataClient('${wshop.iddocumento}');" id="td-usuario-${wshop.iddocumento}">${wshop.usuario} | ${seller}</td>
                        <td onclick="prepareDataClient('${wshop.iddocumento}');" id="td-total-${wshop.iddocumento}">${formatValueBrl(wshop.vltotal)}</td>
                    </tr>`
            tbody.innerHTML += tmpl
        })
    })
}

function apiWshopGetDataSale(iddocumento) {

    //Open Modal
    $('#close_modal').click();
    let modaProcess = { action: 'open' };
    modalProcess(modaProcess);

    let request = { iddocumento: iddocumento, function: 'apiWshopGetDataSale' }

    setTimeout(() => {

        CBappApi(request, function (response) {

            if(response.seller.length == 0){
                toastMsg('ERROR: Vendedor não informado');
                return false;
            }

            //Documen
            documen = response.documen;

            //nfce
            nfce = response.nfce;

            //nfe
            nfe = response.nfe;

            //Form Client
            importSale = true; 
            clickExpedition = false;
            populateFormClient(response.client[0])

            //Form Product
            populateFormItem(response.item)

            //Form Recebimento
            populateFormRecebimento(response.payment)

            //Seller = response;
            sellerData = response.seller[0];            
            $('#combo-user-seller').val(response.seller[0].idpessoa);
            //$('#combo-user-seller').attr('disabled', 'true');

            modaProcess.action = 'close';
            modalProcess(modaProcess);
        })
    }, 500);
}

function getStore() {
    storeData.code = $('#cdempresa_user_log').val();
}

function apiBeginSale() {

    $('#begin_attendance').removeAttr('onclick');
    $('#begin_attendance').css('display', 'none');

    let modaProcess = { action: 'open' };
    modalProcess(modaProcess);

    //Get Instance
    //------------
    getStore();

    //seller
    sellerData.seller_id = $('#combo-user-seller').val();
    sellerData.seller_idpessoa = $('#combo-user-seller :selected').attr('idpessoa');   
    sellerData.seller_nmpessoa = $('#combo-user-seller :selected').text();
    sellerData.obs_seller = $('#obs_seller').val();
    //------------

    //Prepare all data sale
    //sale.documen = documen;
    //sale.nfce = nfce;
    //sale.nfe = nfe;

    if(prevRecycle.count <= 0){
        prevRecycle.count = 0;
        prevRecycle.weight = 0;
    }

    sale.date_time = getDateTime();
    sale.value_total = formatValueNumeric($('#totalVenda').text());
    sale.technical_id = $('#combo-user-technical').val();
    sale.installation = $("input[name='installation']:checked"). val();
    
    sale.seller = sellerData;

    sale.client = clientData;
    sale.item = listItem;
    sale.payment = listRecebimento;
    sale.delivery = delivery;
    sale.expedition = typeExpedition;
    sale.store = storeData;
    sale.prev_recycle = prevRecycle;
    
    let request = { sale: sale, function: 'apiBeginSale' }
    CBappApi(request, (response) => {
        if(response.sale == 'ok'){
            toastMsg('VENDA ABERTA COM SUCESSO!');
            setTimeout(() => {            
                setFacadeJs('homeMonitoring');
                modaProcess.action = 'close';
                modalProcess(modaProcess);
            }, 2000);
        }
    })
}
/* END SALES *****************************************************************************
 ****************************************************************************************/

