
$(document).ready(function () {
    comboStores()
    comboStoreTypeEntity()

    //css atack *********************************
    let comboStoreType = $('#combo-store-type-entity');
    comboStoreType.css('border-color', 'gray');
    let comboStore = $('#combo-store');
    comboStore.css('border-color', 'gray');
    //*******************************************/
});

function prepareForm(fnc) {
    switch (fnc) {
        case 'create_store':
            $('#form_store')[0].reset();
            $('#title-modal').text('Cadastrar Loja');
            $('#submit_store').text('CADASTRAR LOJA');
            $('#submit_store').attr('onClick', 'apiCriateStore()');
            $("#submit_store").attr('disabled', 'false');
            $('#store_code').removeAttr('readonly');
            $("#store_cdchamada").removeAttr('readonly');
            $('#function').attr('value', 'apiCreateStore');
            checkForm()
            break;

        case 'update_store':
            $('#form_store')[0].reset();
            $('#title-modal').text('Alterar Loja');
            $('#submit_store').text('ALTERAR LOJA');
            $('#submit_store').attr('onClick', 'apiUpdateStore()');
            $("#submit_store").attr('disabled', 'false');
            $("#store_code").attr('readonly', 'true');
            $("#store_cdchamada").attr('readonly', 'true');
            $("#combo-store").attr('onChange', 'checkForm()');
            $('#function').attr('value', 'apiUpdateStore');
            $('#prepareUpdateForm').click();
            break;
    }
}

window.addEventListener('load', function () {
    loadListStore();
})

function loadListStore() {

    let tbody = id('tbody')
    let request = { function: 'apiListStore' }
    $("#tbody").empty();

    CBappApi(request, function(response){
        response.forEach((store, index) => {
                let tmpl = `<tr id="store-${store.store_code}" class="modal-trigger" data-modal="modal_store" style="cursor: pointer;">
                            <td onclick="apiGetStore('${store.store_code}','apiGetStore')" id="td-store-cd-empresa-${store.store_code}">${store.store_code}</td>
                            <td onclick="apiGetStore('${store.store_code}','apiGetStore')" id="td-store-cd-cdchamada-${store.store_code}">${store.store_document_cnpj}</td>
                            <td onclick="apiGetStore('${store.store_code}','apiGetStore')" id="td-store-type-entity-${store.store_code}">${store.store_type_entity}</td>
                            <td onclick="apiGetStore('${store.store_code}','apiGetStore')" id="td-store-cd-chamada-matriz-${store.store_code}">${store.store_code_matriz}</td>
                            <td onclick="apiGetStore('${store.store_code}','apiGetStore')" id="td-store-nmcidade-${store.store_code}">${store.store_city}</td>
                            <td onclick="apiGetStore('${store.store_code}','apiGetStore')" id="td-store-nmbairro-${store.store_code}">${store.store_district}</td>                            
                            <td onclick="apiGetStore('${store.store_code}','apiGetStore')" id="td-store-status-${store.store_code}">${store.store_status}</td>
                        </tr>`
                tbody.innerHTML += tmpl
            })
    })
}

function getPjReceitaFederal() {

    $('#preload').fadeIn(0);

    let request = $('#store_document_cnpj').val()

    getClientReceitaFederal(request, (response) => {
        try {
            let store_responsible_name;
            let cdchamada = request;
            let client = response;
            fone = client.telefone.replace(" ", ""); 
            client.fone = fone.split(" /");   

            let nmfantasia = client.fantasia;

            if(client.qsa.length > 0) {
                store_responsible_name = client.qsa[0].nome;
            } else {
                store_responsible_name = '';
            }
            
            if(client.fone.length > 1) {                
                fone1 = client.fone[0];
                fone2 = client.fone[1].replace(" ", "");
            } else {
                fone1 = fone;
                fone2 = '';
            }
           

            dataClient = {
                store_document_cnpj: cdchamada,
                store_document_name_fantasy: nmfantasia,
                store_document_rsocial: client.nome,
                store_phone1: fone1,
                store_phone2: fone2,
                store_zip_code: client.cep,
                store_city: client.municipio,
                store_district: client.bairro,
                store_state_code: client.uf,
                store_address: client.logradouro,
                store_address_number: client.numero,
                store_address_complement: client.complemento
            }

            dataClient.store_zip_code = dataClient.store_zip_code.replace(".", "");
            dataClient.store_address = dataClient.store_address.replace("R ", "RUA ");
            dataClient.store_address = dataClient.store_address.replace("AV ", "AVENIDA ");

            $('#store_document_cnpj').val(dataClient.store_document_cnpj)
            $('#store_document_rsocial').val(dataClient.store_document_rsocial)
            $('#store_document_name_fantasy').val(dataClient.store_document_name_fantasy)
            $('#store_phone1').val(dataClient.store_phone1)
            $('#store_phone2').val(dataClient.store_phone2.replace(" ", ""))
            $('#store_responsible_name').val(store_responsible_name)
            $('#store_state_code').val(dataClient.store_state_code)
            $('#store_city').val(dataClient.store_city)
            $('#store_district').val(dataClient.store_district)
            $('#store_zip_code').val(dataClient.store_zip_code)
            $('#store_address').val(dataClient.store_address)
            $('#store_address_number').val(dataClient.store_address_number)
            $('#store_address_complement').val(dataClient.store_address_complement)

            $('#preload').fadeOut(0);
            
        }
        catch (err) {
            $('#preload').fadeOut(0);
            toastMsg('DADOS NÃO ENCONTRADOS');     
            $('#preload').fadeOut(0);      
        }
    });
}

function apiCriateStore() {

    //prepareForm('create_store');

let func = 'apiCriateStore'

let store_code = id('store_code').value
let comboStoreType = id('combo-store-type-entity')
let store_type_entity = comboStoreType.options[comboStoreType.selectedIndex].value
let store_document_cnpj = id('store_document_cnpj').value
let store_document_rsocial = id('store_document_rsocial').value
let store_document_name_fantasy = id('store_document_name_fantasy').value
let store_document_inscmunicipal = id('store_document_inscmunicipal').value
let store_document_inscestadual = id('store_document_inscestadual').value
let combo = id('combo-store')
let store_code_matriz = combo.options[combo.selectedIndex].value
let store_phone1 = id('store_phone1').value
let store_phone2 = id('store_phone2').value
let store_ramal1 = id('store_ramal1').value
let store_ramal2 = id('store_ramal2').value
let store_host_local_app = id('store_host_local_app').value
let store_host_local_app_ip = id('store_host_local_app_ip').value
let store_responsible_name = id('store_responsible_name').value
let store_responsible_phone = id('store_responsible_phone').value
let store_responsible_document_cpf = id('store_responsible_document_cpf').value
let store_geolocation = id('store_geolocation').value
let store_state_code = id('store_state_code').value
let store_city = id('store_city').value
let store_district = id('store_district').value
let store_zip_code = id('store_zip_code').value
let store_address = id('store_address').value
let store_address_number = id('store_address_number').value
let store_address_complement = id('store_address_complement').value
let store_status = $("input[id='store_status']:checked").val(); if (store_status != 'A') { store_status = '' }
/*
let store_idpessoa: id('').value
let store_logo: id('').value
let store_logo_matriz: id('').value
let store_order: id('').value
*/

    let request =
    {
        store_code: store_code,
        store_type_entity: store_type_entity,
        store_document_cnpj: store_document_cnpj,
        store_document_rsocial: store_document_rsocial,
        store_document_name_fantasy: store_document_name_fantasy,
        store_document_inscmunicipal: store_document_inscmunicipal,
        store_document_inscestadual: store_document_inscestadual,
        store_code_matriz: store_code_matriz,
        store_phone1: store_phone1,
        store_phone2: store_phone2,
        store_ramal1: store_ramal1,
        store_ramal2: store_ramal2,
        store_host_local_app: store_host_local_app,
        store_host_local_app_ip: store_host_local_app_ip,
        store_responsible_name: store_responsible_name,
        store_responsible_phone: store_responsible_phone,
        store_responsible_document_cpf: store_responsible_document_cpf,
        store_geolocation: store_geolocation,        
        store_state_code: store_state_code,
        store_city: store_city,
        store_district: store_district,
        store_zip_code: store_zip_code,
        store_address: store_address,
        store_address_number: store_address_number,
        store_address_complement: store_address_complement,
        store_country: 'BRASIL',
        store_status: store_status,
        function: func
    }

    console.log(request);

    CBappApi(request, function(response){
        if (response.resMsg == 'ok:create') {
            id('modal-delete').click();
            toastMsg('Loja cadastrada!')
            loadListStore()
        }
        if (response.resMsg == 'error:duplicate') {                        
            toastMsg('ERROR: Loja já cadastrada.')
        }
    })
}

function apiUpdateStore() {    

    //$("#submit_store").attr('disabled', 'disabled');

let func = 'apiUpdateStore'  

let store_code = $('#store_code').val()
if(store_code.length <= 4) {}

let comboStoreType = id('combo-store-type-entity')
let store_type_entity = comboStoreType.options[comboStoreType.selectedIndex].value

let store_document_cnpj = $('#store_document_cnpj').val()

let store_document_rsocial = $('#store_document_rsocial').val()

let store_document_name_fantasy = $('#store_document_name_fantasy').val()

let store_document_inscmunicipal = $('#store_document_inscmunicipal').val()

let store_document_inscestadual = $('#store_document_inscestadual').val()

let combo = id('combo-store')
let store_code_matriz = combo.options[combo.selectedIndex].value

let store_phone1 = $('#store_phone1').val()

let store_phone2 = $('#store_phone2').val()

let store_ramal1 = $('#store_ramal1').val()

let store_ramal2 = $('#store_ramal2').val()

let store_host_local_app = $('#store_host_local_app').val()

let store_host_local_app_ip = $('#store_host_local_app_ip').val()

let store_responsible_name = $('#store_responsible_name').val()

let store_responsible_phone = $('#store_responsible_phone').val()

let store_responsible_document_cpf = $('#store_responsible_document_cpf').val()

let store_geolocation = $('#latitude').val()+','+$('#longitude').val();

let store_state_code = $('#store_state_code').val()

let store_city = $('#store_city').val()

let store_district = $('#store_district').val()

let store_zip_code = $('#store_zip_code').val()

let store_address = $('#store_address').val()

let store_address_number = $('#store_address_number').val()

let store_address_complement = $('#store_address_complement').val()

let store_status = $("input[id='store_status']:checked").val(); if (store_status != 'A') { store_status = '' }


    let request =
    {
        store_code: store_code,
        store_type_entity: store_type_entity,
        store_document_cnpj: store_document_cnpj,
        store_document_rsocial: store_document_rsocial,
        store_document_name_fantasy: store_document_name_fantasy,
        store_document_inscmunicipal: store_document_inscmunicipal,
        store_document_inscestadual: store_document_inscestadual,
        store_code_matriz: store_code_matriz,
        store_phone1: store_phone1,
        store_phone2: store_phone2,
        store_ramal1: store_ramal1,
        store_ramal2: store_ramal2,
        store_host_local_app: store_host_local_app,
        store_host_local_app_ip: store_host_local_app_ip,
        store_responsible_name: store_responsible_name,
        store_responsible_phone: store_responsible_phone,
        store_responsible_document_cpf: store_responsible_document_cpf,
        store_geolocation: store_geolocation,        
        store_state_code: store_state_code,
        store_city: store_city,
        store_district: store_district,
        store_zip_code: store_zip_code,
        store_address: store_address,
        store_address_number: store_address_number,
        store_address_complement: store_address_complement,
        store_country: 'BRASIL',
        store_status: store_status,
        function: func
    }
    
    CBappApi(request, function(response){
        if (response.resMsg == 'ok:update') {
                id('modal-delete').click();
                toastMsg('Alteração realizada!');
                data = request;
                $('#td-store-cd-empresa-' + data.store_code).html(data.store_code);
                $('#td-store-cd-cdchamada-' + data.store_code).html(data.store_document_cnpj);
                $('#td-store-type-entity-' + data.store_code).html(data.store_type_entity);
                $('#td-store-cd-chamada-matriz-' + data.store_code).html(data.store_code_matriz);
                $('#td-store-nmcidade-' + data.store_code).html(data.store_city);
                $('#td-store-nmbairro-' + data.store_code).html(data.store_district);
                $('#td-store-status-' + data.store_code).html(data.store_status);

            } else {
                toastMsg('Erro no processo, tente mais tarde')
            }
    })
}

function apiGetStore(id, fnc) {
            
            prepareForm('update_store');
            let request = { id: id, function: fnc}
            
            CBappApi(request, function(response){
                let data = response

                geolocation = JSON.stringify(data.store_geolocation).replace(/"/g, "").split(',');
                latitude = geolocation[0];
                longitude = geolocation[1];

    $('#store_code').val(JSON.stringify(data.store_code).replace(/"/g, ""))
    if(JSON.stringify(data.store_code).replace(/"/g, "") === ''){$('#store_code').val('')};

    $('#store_document_cnpj').val(JSON.stringify(data.store_document_cnpj).replace(/"/g, ""))
    if(JSON.stringify(data.store_document_cnpj).replace(/"/g, "") == 'null'){$('#store_document_cnpj').val('')}

    $('#store_document_rsocial').val(JSON.stringify(data.store_document_rsocial).replace(/"/g, ""))
    if(JSON.stringify(data.store_document_rsocial).replace(/"/g, "") == 'null'){$('#store_document_rsocial').val('')}

    $('#store_document_name_fantasy').val(JSON.stringify(data.store_document_name_fantasy).replace(/"/g, ""))
    if(JSON.stringify(data.store_document_name_fantasy).replace(/"/g, "") == 'null'){$('#store_document_name_fantasy').val('')}

    $('#store_document_inscmunicipal').val(JSON.stringify(data.store_document_inscmunicipal).replace(/"/g, ""))
    if(JSON.stringify(data.store_document_inscmunicipal).replace(/"/g, "") == 'null'){$('#store_document_inscmunicipal').val('')}

    $('#store_document_inscestadual').val(JSON.stringify(data.store_document_inscestadual).replace(/"/g, ""))
    if(JSON.stringify(data.store_document_inscestadual).replace(/"/g, "") == 'null'){$('#store_document_inscestadual').val('')}

    $('#store_phone1').val(JSON.stringify(data.store_phone1).replace(/"/g, ""))
    if(JSON.stringify(data.store_phone1).replace(/"/g, "") == 'null'){$('#store_phone1').val('')}

    $('#store_phone2').val(JSON.stringify(data.store_phone2).replace(/"/g, ""))
    if(JSON.stringify(data.store_phone2).replace(/"/g, "") == 'null'){$('#store_phone2').val('')}

    $('#store_ramal1').val(JSON.stringify(data.store_ramal1).replace(/"/g, ""))
    if(JSON.stringify(data.store_ramal1).replace(/"/g, "") == 'null'){$('#store_ramal1').val('')}

    $('#store_ramal2').val(JSON.stringify(data.store_ramal2).replace(/"/g, ""))
    if(JSON.stringify(data.store_ramal2).replace(/"/g, "") == 'null'){$('#store_ramal2').val('')}

    $('#store_host_local_app').val(JSON.stringify(data.store_host_local_app).replace(/"/g, ""))
    if(JSON.stringify(data.store_host_local_app).replace(/"/g, "") == 'null'){$('#store_host_local_app').val('')}

    $('#store_host_local_app_ip').val(JSON.stringify(data.store_host_local_app_ip).replace(/"/g, ""))
    if(JSON.stringify(data.store_host_local_app_ip).replace(/"/g, "") == 'null'){$('#store_host_local_app_ip').val('')}
    
    $('#store_responsible_name').val(JSON.stringify(data.store_responsible_name).replace(/"/g, ""))
    if(JSON.stringify(data.store_responsible_name).replace(/"/g, "") == 'null'){$('#store_responsible_name').val('')}

    $('#store_responsible_phone').val(JSON.stringify(data.store_responsible_phone).replace(/"/g, ""))
    if(JSON.stringify(data.store_responsible_phone).replace(/"/g, "") == 'null'){$('#store_responsible_phone').val('')}

    $('#store_responsible_document_cpf').val(JSON.stringify(data.store_responsible_document_cpf).replace(/"/g, ""))
    if(JSON.stringify(data.store_responsible_document_cpf).replace(/"/g, "") == 'null'){$('#store_responsible_document_cpf').val('')}

    $('#latitude').val(JSON.stringify(latitude).replace(/"/g, ""))
    if(JSON.stringify(data.store_geolocation).replace(/"/g, "") == 'null'){$('#latitude').val('')}

    $('#longitude').val(JSON.stringify(longitude).replace(/"/g, ""))
    if(JSON.stringify(data.store_geolocation).replace(/"/g, "") == 'null'){$('#longitude').val('')}

    $('#store_state_code').val(JSON.stringify(data.store_state_code).replace(/"/g, ""))
    if(JSON.stringify(data.store_state_code).replace(/"/g, "") == 'null'){$('#store_state_code').val('')}

    $('#store_city').val(JSON.stringify(data.store_city).replace(/"/g, ""))
    if(JSON.stringify(data.store_city).replace(/"/g, "") == 'null'){$('#store_city').val('')}

    $('#store_district').val(JSON.stringify(data.store_district).replace(/"/g, ""))
    if(JSON.stringify(data.store_district).replace(/"/g, "") == 'null'){$('#store_district').val('')}

    $('#store_zip_code').val(JSON.stringify(data.store_zip_code).replace(/"/g, ""))
    if(JSON.stringify(data.store_zip_code).replace(/"/g, "") == 'null'){$('#store_zip_code').val('')}

    $('#store_address').val(JSON.stringify(data.store_address).replace(/"/g, ""))
    if(JSON.stringify(data.store_address).replace(/"/g, "") == 'null'){$('#store_address').val('')}

    $('#store_address_number').val(JSON.stringify(data.store_address_number).replace(/"/g, ""))
    if(JSON.stringify(data.store_address_number).replace(/"/g, "") == 'null'){$('#store_address_number').val('')}

    $('#store_address_complement').val(JSON.stringify(data.store_address_complement).replace(/"/g, ""))
    if(JSON.stringify(data.store_address_complement).replace(/"/g, "") == 'null'){$('#store_address_complement').val('')}

    let store_status = $("input[id='store_status']:checked").val(); if (store_status != 'A') { store_status = '' }
    let sts = JSON.stringify(data.store_status).replace(/"/g, "");           

    let loj = JSON.stringify(data.store_code_matriz).replace(/"/g, "");
    $('#combo-store').val(loj);

    let stp = JSON.stringify(data.store_type_entity).replace(/"/g, "");
    $('#combo-store-type-entity').val(stp)

    if (sts == 'A') { $('#store_status').prop('checked', true); }
    checkForm()

    })
}

function checkForm() {
    $('#submit_store').removeAttr('disabled');
/*
    $("#submit_store").attr('disabled', 'disabled');

    let user_first_name = $('#user_first_name').val();
    let user_last_name = $('#user_last_name').val();
    let user_phone = $('#user_phone').val();
    let user_email = $('#user_email').val();
    let user_pass = $('#user_pass').val();
    let user_confirm_pass = $('#user_confirm_pass').val();
    let user_status = $('#user_status').val();
    var user_store = $("#combo-store option:selected").val();

    if (user_first_name.length < 4 || user_last_name.length < 4 || user_phone.length < 10 || user_email.length < 10 || user_confirm_pass != user_pass || user_store == '--Selecione--') {

        $("#submit_store").attr('disabled', 'disabled');
        if (user_pass.lenght != '' & user_confirm_pass != '') {
            if (user_pass != user_confirm_pass) {
                toastMsg('Senhas não conferem.');
                $('#user_confirm_senha').fucus();
            }
        }

    } else {
        $("#submit_store").removeAttr('disabled');
    }*/
}