/** Axios Resolver Cors ***********************************************/
var ResolverCorsPolicyAxios='https://cors-anywhere.herokuapp.com/';
/**********************************************************************/

/******************** Abstract Select ID Element **********************/
function id(el) { return document.getElementById(el); }
/**********************************************************************/


/** CONFIG STORE ************/
let timeSync = 1; //minutes
let store_code = '001'
let store_name = 'MADALENA'
let store_port = '8085'
/****************************/


/** Calc Time ***************/
timeSync = 60000 * timeSync;
/****************************/


/** Functions API
 * getIp = Return Ip;
 * 
 * 
 * SetServerCBapp {
 *  ip
 *  uri  
 * }
 * 
 * SetServerStore {
 *  store_code
 *  store_name
 *  store_ip
 *  store_api_uri
 * }
 *  
 * **/

 /* BEGIN OBJECTS ******************/


let store = new Object();
store.code = store_code;
store.name = store_name;
store.port = store_port;
/**********************************/

function getIp()
{
    let request = { function: 'getIp' }

    CBappSync(request, (response) => {
        try {
            id('ip').innerText = response;
            store.ip = response;
        }
        catch (err) {            
            console.log(err);
        }
    })
}

/** Start getIp */
getIp();
/****************/
//setInterval(() => {
//    getIp();
//}, timeSync);
/****************/


function SetServerStore(){
    let store_api_uri = `http://${store.ip}:${store.port}/`;
    request = {
        function : 'SetServerStore',
        store_code : store.code,
        store_name : store.name,
        store_ip : store.ip,
        store_api_uri : store_api_uri
    }

    CBappSync(request, (response) => {
        try {
            console.log(response)
        }
        catch (err) {            
            console.log(err);
        }
    })
    
}

//setTimeout(() => {
//    SetServerStore();
//}, 7000);
//setInterval(() => {
//    SetServerStore();
//}, timeSync+7000);



function setServerCBapp(){
    let store_api_uri = `http://${store.ip}:${store.port}/`;
    request = {
        function : 'SetServerCBapp',
        cbapp_server_ip : store.ip,
        cbapp_server_uri : store_api_uri
    }

    CBappSync(request, (response) => {
        try {
            console.log(response)
        }
        catch (err) {            
            console.log(err);
        }
    })
    
}

//setTimeout(() => {
//    SetServerCBapp();
//}, 7500);
//setInterval(() => {
//    SetServerStore();
//}, timeSync+7500);



/** @CBappSync
 *  By Neysoft - Neylor Cesar.
 *  _________________________________________
 *  Execute background request and response.
 *  Based axios framework v0.18.0 | (c) 2018.
 *  Return Callbak Promise based HTTP client.
 ******************************************************************/
function CBappSync(cRequest, sResponse) {
    let config = {
        method: 'POST',
        url: ResolverCorsPolicyAxios+'https://www.casadabateria.com.br/cbappsync/cbappsync.php',
        data: cRequest,
        headers: {
            'Access-Control-Allow-Origin': '*',
            'Content-Type': 'multipart/form-data',
            'Content-Type': 'application/x-www-form-urlencoded'
        },
        json: true
    };
    axios(config)
        .then((res) => {
            response = res.data
            sResponse(response);
        })
        .catch((error) => {
            
        })
}
/******************************************************************/
