<?php
namespace CBapp\Controller;

use \CBapp\View\View as View;

class ControllerWshop
{

    private $bundle;
    private $container;

    public function __construct()
    {
        $this->container = \CBappContainer();
    }

    public function homeWshopSales(){
        $bundle['facade_off'] = true;
        $bundle['view'] = 'ViewWshopHomeSales';
        new View($bundle);
    }

    public function apiCheckClientLocalExists($bundle){
        $return = $this->container['retrieve_wshop']->retrieve($bundle);

        if($return['dao_response_local']['status_exist'] == true){
            header('Content-Type: application/json');
            header( 'HTTP/1.1 200 Ok' );
            print_r(json_encode(true));die;
        } else {
            header('Content-Type: application/json');
            header( 'HTTP/1.1 200 Ok' );
            print_r(json_encode(false));die;
        }
    }

    public function apiWshopListSales($bundle){
        if (!isset($bundle['dao_response'])):
            if(!isset($bundle['request']['date'])):
                $bundle['request']['date'] = date('d/m/Y');
            else:
                if(!$bundle['request']['date']):
                    $bundle['request']['date'] = date('d/m/Y');
                endif;
            endif;
            $this->container['retrieve_wshop']->retrieve($bundle);
        else:
            $data = $bundle['dao_response'];
            header('Content-Type: application/json');
            print_r(json_encode($data));die;
        endif;
    }

    public function apiWshopGetDataSale($bundle){
        if (!isset($bundle['dao_response'])):            
            $this->container['retrieve_wshop']->retrieve($bundle);
        else:
            $data = $bundle['dao_response'];
            header('Content-Type: application/json');
            print_r(json_encode($data));die;
        endif;
    }

    public function apiWshopGetClient($bundle){
        
        if (!isset($bundle['dao_response'])):            
            $this->container['retrieve_wshop']->retrieve($bundle);
        else:
            if(!$bundle['dao_response']['client'][0]){
                $data['code'] = 401;
                $data['message'] = 'Client not found';
            } else {
                $data = $bundle['dao_response']['client'][0];
                $data['code'] = 200;            
            }
            header('Content-Type: application/json');
            print_r(json_encode($data));die;
        endif;
    }

    public function apiWshopGetClientPhone($bundle){
        if (!isset($bundle['dao_response'])):            
            $this->container['retrieve_wshop']->retrieve($bundle);
        else:
            $data = $bundle['dao_response']['client'][0];
            header('Content-Type: application/json');
            print_r(json_encode($data));die;
        endif;
    }

    public function apiWshopListProduct($bundle){
        if (!isset($bundle['dao_response'])):            
            $this->container['retrieve_wshop']->retrieve($bundle);
        else:
            $data = $bundle['dao_response'];
            header('Content-Type: application/json');
            print_r(json_encode($data));die;
        endif;
    }

    public function apiGetPagamentoCombo($bundle){
        if (!isset($bundle['dao_response'])):            
            $this->container['retrieve_wshop']->retrieve($bundle);
        else:
            $data = $bundle['dao_response']['pagamento'];
            header('Content-Type: application/json');
            print_r(json_encode($data));die;
        endif;
    }

    public function apiWshopGetAddressCep($bundle){
        
        $resDao = $this->container['retrieve_wshop']->retrieve($bundle);
        if($resDao['dao_response']['status_exist'] == true){            
            header('Content-Type: application/json');
            header( 'HTTP/1.1 200 Ok' );
            print_r(json_encode($resDao['dao_response']['address'][0]));die;
        } else {
            header('Content-Type: application/json');
            //header( 'HTTP/1.1 404 Not Found' );
            print_r(json_encode(false));die;
        }
    }

    public function apiWshopGetAddress($bundle){
        
        $resDao = $this->container['retrieve_wshop']->retrieve($bundle);
        if($resDao['dao_response']['status_exist'] == true){            
            header('Content-Type: application/json');
            header( 'HTTP/1.1 200 Ok' );
            print_r(json_encode($resDao['dao_response']['address']));die;
        } else {
            header('Content-Type: application/json');
            header( 'HTTP/1.1 404 Not Found' );
            print_r(json_encode(false));die;
        }
    }

    public function apiWsGetTotalFiscal($bundle){
        $return =  $this->container['retrieve_wshop']->retrieve($bundle);
        if($return['status_fiscal'] == 0){
            $response['fiscal']['status'] = false;
        } else {
            $response['fiscal'] = $return;
            $response['fiscal']['status'] = true;
        }
        
            header('Content-Type: application/json');
            header( 'HTTP/1.1 200 Ok' );
            print_r(json_encode($response));die;
        
        
    }

    public function apiWsGetListFiscal($bundle){

        $return =  $this->container['retrieve_wshop']->retrieve($bundle);
        
            header('Content-Type: application/json');
            header( 'HTTP/1.1 200 Ok' );
            print_r(json_encode($return));die;        
    }

    public function apiWsGetTotalFiscalSelected($bundle)
    {
        $return =  $this->container['retrieve_wshop']->retrieve($bundle);

        if($return['status_return']){
            header('Content-Type: application/json');
            header( 'HTTP/1.1 200 Ok' );
            print_r(json_encode($return['dao_response']));die;
        }
    }

    public function  apiUpdateClientLocal($bundle){
        $return = $this->container['update_wshop']->update($bundle);

        if($return['dao_response_local']['status_update'] == true){
            header('Content-Type: application/json');
            header( 'HTTP/1.1 200 Ok' );
            print_r(json_encode(true));die;
        } else {
            header('Content-Type: application/json');
            header( 'HTTP/1.1 404 Not Found' );
            print_r(json_encode(false));die;
        }
    }

    public function  apiCreateClientLocal($bundle){
        $return = $this->container['create_wshop']->create($bundle);

        if($return['dao_response_local']['status_create'] == true){
            header('Content-Type: application/json');
            header( 'HTTP/1.1 200 Ok' );
            print_r(json_encode(true));die;
        } else {
            header('Content-Type: application/json');
            print_r(json_encode(false));die;
        }
    }
    
    public function  apiForceCreateClientLocal($bundle){        
        $bundle['request']['function'] = 'apiCheckClientLocalExists';
        $checkClient = $this->container['retrieve_wshop']->retrieve($bundle);

        if($checkClient['dao_response_local']['status_exist'] == true){

            //client exists not create return false
            print_r(json_encode(false));

        } else {
            //client not exists prepare create

            //get data address
            $bundle['request']['function'] = 'apiWshopGetAddressCep';
            $addr = $this->container['retrieve_wshop']->retrieve($bundle);
            if($addr['dao_response']['status_exist'] == true){            
                $bundle['request']['idbairro'] = $addr['dao_response']['address'][0]['idbairro'];
                $bundle['request']['idcidade'] = $addr['dao_response']['address'][0]['idcidade'];
            }            
            
            $bundle['request']['client'] = $bundle['request'];
            $bundle['request']['function'] = 'apiCreateClientLocal';
            $return = $this->container['create_wshop']->create($bundle);

            if($return['dao_response_local']['status_create'] == true){
                header('Content-Type: application/json');
                header( 'HTTP/1.1 200 Ok' );
                print_r(json_encode(true));die;
            } else {
                header('Content-Type: application/json');
                print_r(json_encode(false));die;
            }
        }
    }

}
